#!/usr/bin/bash

DATE=`date '+%Y%m%d_%H%M%S'`

this=benchmark_homog
log=$this.log
dir=.
savedir=$DATE

echo "### $DATE - homog ###"

bin=../pm
cfg_list=( homog_bpm_2D_32x128.cfg \
	   homog_bpm_2D_64x256.cfg \
	   homog_bpm_2D_128x512.cfg \
	   homog_bpm_2D_256x1024.cfg \
	   homog_bpm_2D_512x2048.cfg \
	   homog_bpm_2D_1024x4096.cfg\
	   homog_bpm_2D_2048x8192.cfg )

# options
compare="-c"
store="-r homog_qor.csv"
cpu="-c"
gpu="  "
quiet="-q"

for cfg in ${cfg_list[@]}; do
    if ! test -f "$dir/$cfg"
    then
	echo "$cfg does not exist." | tee -a $dir/$log;
	exit;
    fi
    echo "./$bin -i $dir/$cfg $cpu $compare $store" | tee -a $dir/$log;
    ./$bin $quiet -i $dir/$cfg $cpu $compare $store | tee -a $dir/$log;
done
echo "finished." | tee -a $dir/$log; 
