#!/usr/bin/bash

DATE=`date '+%Y%m%d_%H%M%S'`
echo $1

this=benchmark_homog_cpu
log=$this.log
savedir=$DATE

echo "### $this, $DATE, $log ###"
echo $1
bin_list=( ../pm0 \
    ../pm1 \
    ../pm2 \
    ../pm3 )

cfg_list=( homog_bpm_2D_32x128.cfg \
    homog_bpm_2D_64x256.cfg \
    homog_bpm_2D_128x512.cfg \
    homog_bpm_2D_256x1024.cfg \
    homog_bpm_2D_512x2048.cfg \
    homog_bpm_2D_1024x4096.cfg \
    homog_bpm_2D_2048x8192.cfg )

# options
compare="-c"
store="-r $this.csv"
cpu="-p"
gpu="-g"
quiet="-q"
iterations="-n 10 --skipFirst"

for bin in ${bin_list[@]}; do
    if ! test -f "$bin"
    then
	echo "$bin does not exist." | tee -a $log;
	exit;
    fi
    for cfg in ${cfg_list[@]}; do
	if ! test -f "$cfg"
	then
	    echo "$cfg does not exist." | tee -a $log;
	    exit;
	fi
	echo "$bin $1 $quiet -i $cfg $cpu $iterations $compare $store 2>&1" | tee -a $log;
	$bin $1 $quiet -i $cfg $cpu $iterations $compare $store  2>&1 | tee -a $log;
    done
done
echo "finished." | tee -a $log; 
