#!/usr/bin/bash

DATE=`date '+%Y%m%d_%H%M%S'`

this=batch_run.sh
log=log
dir=.
savedir=$DATE

echo "### $DATE - wguide ###"

bin= ../pm

cfg_list=( wguide_bpm_2D_32x128.cfg \
	   wguide_bpm_2D_64x256.cfg \
	   wguide_bpm_2D_128x512.cfg \
	   wguide_bpm_2D_256x1024.cfg \
	   wguide_bpm_2D_512x2048.cfg \
	   wguide_bpm_2D_1024x4096.cfg\
	   wguide_bpm_2D_2048x8192.cfg )

# options
compare="-c"
store="-r wguide_qor.csv"
cpu="-p"
gpu="  "
quiet="-q"

for cfg in ${cfg_list[@]}; do
    if ! test -f "$dir/$cfg"
    then
	echo "$cfg does not exist." | tee -a $dir/$log;
	exit;
    fi
    echo "./$bin -i $dir/$cfg $cpu $compare" | tee -a $dir/$log;
    ./$bin $quiet -i $dir/$cfg $cpu $compare | tee -a $dir/batch_run.$log;
done
echo "finished." | tee -a $dir/$log; 
