#!/usr/bin/bash

DATE=`date '+%Y%m%d_%H%M%S'`

this=benchmark_homog
log=$this.log
dir=.
savedir=$DATE

echo "### $DATE - homog ###"

bin=../pm
cfg_list=( homog_bpm_3D_16x16x64.cfg \
	   homog_bpm_3D_32x32x128.cfg \
	   homog_bpm_3D_64x64x256.cfg \
	   homog_bpm_3D_128x128x512.cfg \
	   homog_bpm_3D_256x256x1024.cfg \
	   homog_bpm_3D_512x512x2048.cfg \
	   homog_bpm_3D_1024x1024x4096.cfg \
	   homog_bpm_3D_2048x2048x8192.cfg )

# options
compare="-c"
store="-r $this.csv"
cpu="-c"
gpu="-g"
quiet="-q"
iterations="-n 5 --skipFirst"

for cfg in ${cfg_list[@]}; do
    if ! test -f "$cfg"
    then
	echo "$cfg does not exist." | tee -a $log;
	exit;
    fi
    echo "./$bin $1 $quiet -i $cfg $cpu $gpu $iterations $compare $store 2>&1" | tee -a $log;
    ./$bin $1 $quiet -i $cfg $cpu $gpu $compare $store 2>&1 | tee -a $log;
;done
echo "finished." | tee -a $log; 
