#!/usr/bin/bash

DATE=`date '+%Y%m%d'`

this=configure
log=$this.$DATE.log

if [ -z "$1" ]; then 
    echo usage: please specify setup, i.e. none, debug, timer, flux
    exit
fi

echo "./configure.sh will delete all pm executables before linking the executables of the specified configuration. Confirm with 'y' if you want to configure an existing environment ('none', 'timer', 'flux', 'debug', 'all)!
Do you want to continue? (y/n)"
read ANSWER

if [ $ANSWER = "n" ]; then
    echo "Will not delete executables and exit. Please save-copy or rename the executables and re-configure. Exiting."
    exit
fi 

echo "Deleting all executables."
rm pm0 pm1 pm2 pm3 2>&1
echo "Executables deleted."

echo "Reconfigure to $1"

if [ $1 = "none" ]; then
    ln -sf ../lib/__none/pm* .
    echo "Linking ../lib/__none/pm* to ./ done."
    ln -sfr ../lib/__none/lib* ..
    echo "Linking ../lib/__none/lib* to ../ done."
fi

if [ $1 = "debug" ]; then
    ln -sf ../lib/__debug/pm* . 
    echo "Linking ../lib/__debug/pm* to ./ done."
    ln -sfr ../lib/__debug/lib* ..
    echo "Linking ../lib/__debug/lib* to ../ done."
fi

if [ $1 = "timer" ]; then
    ln -sf ../lib/__timer/pm* . 
    echo "Linking ../lib/__timer/pm* to ./ done."
    ln -sfr ../lib/__timer/lib* .. 
    echo "Linking ../lib/__timer/lib* to ../ done."
fi

if [ $1 = "flux" ]; then
    ln -sf ../lib/__flux/pm* . 
    echo "Linking ../lib/__timer_flux/pm* to ./ done."
    ln -sfr ../lib/__flux/lib* .. 
    echo "Linking ../lib/__timer_flux/lib* to ../ done."
fi

if [ $1 = "all" ]; then
    ln -sf ../lib/__all/pm* . 
    echo "Linking ../lib/__all/pm* to ./ done."
    ln -sfr ../lib/__all/lib* .. 
    echo "Linking ../lib/__all/lib* to ../ done."
fi

echo "The benchmark is now configured to run $1. Exiting."

exit




