#include <cmath>
#include <complex>
#include <algorithm>
#include <iostream>
#include <fstream>

#include "Array.h"
#include "fftw++.h"

#ifndef PI
#define PI 3.14159265
#endif

#ifndef IMPEDANCE_VACUUM
#define IMPEDANCE_VACUUM 376.73031346 //mu0*c0
#endif

#ifndef TOLERANCE
#define TOLERANCE 1E-4
#endif

typedef std::complex<double> cpx;

/* 3D vectorial method */

void YOUR_vectorial_3D(cpx* EX, cpx* EY, cpx* EZ, double* F, 
		       const cpx* N, const cpx* KX, const double* X, const cpx* KY, const double* Y, 
		       const double k0, const double dz, const double dy, const double dx, 
		       const int nz, const int ny, const int nx, 
		       const bool do_evanescent_modes = true, const bool is_debug = false);

/* 2D vectorial method */

void YOUR_vectorial_2D(cpx* EX, cpx* EY, cpx* EZ, double* F, 
		       const cpx* N, const cpx* KX, const double* X,
		       const double k0, const double dz, const double dx, 
		       const int nz, const int nx, 
		       const bool do_evanescent_modes = true, const bool is_debug = false);

/* 3D scalar method */

void YOUR_scalar_3D(cpx* E, double* F, 
		    const cpx* N, const cpx* KX, const double* X, const cpx* KY, const double* Y, 
		    const double k0, const double dz, const double dy, const double dx, 
		    const int nz, const int ny, const int nx, 
		    const bool do_evanescent_modes = true, const bool is_TE = true, const bool is_debug = false);

/* 2D scalar method */

void YOUR_scalar_2D(cpx* E, double* F,
		    const cpx* N, const cpx* KX, const double* X,
		    const double k0, const double dz, const double dx,
		    const int nz, const int nx,
		    const bool do_evanescent_modes = true, const bool is_TE = true, const bool is_debug = false);
