#include <your_kernel.h>
#include <iostream>
#include <stdio.h>

/*
 *  GPU kernels
 */

/*
 *  3D vectorial
 */


__global__ void YOUR_kernel_3D( cufftDoubleComplex* SX, cufftDoubleComplex* SY, cufftDoubleComplex* SZ,
			        cufftDoubleComplex* EX, cufftDoubleComplex* EY, cufftDoubleComplex* EZ, double* F, 
                                cufftDoubleComplex* N, 
			        cufftDoubleComplex* KX, double* X, 
			        cufftDoubleComplex* KY, double* Y, 
			        double k0, double dz, double dx, double dy, int nx, int ny, int k, 
                                bool do_evanescent_modes ) {
	
	/* EXAMPLE
	 *
	 *   int i = blockIdx.y * blockDim.y + threadIdx.y; // space index X
	 *   int j = blockIdx.x * blockDim.x + threadIdx.x; // space index Y
         *   if(i<nx && j<ny) {
         *   }
         */

}

/* REMARK: Use YOUR_kernel_3D_2 with Split-Step algorithms like for example the BPM */
__global__ void YOUR_kernel_3D_2( cufftDoubleComplex* SX, cufftDoubleComplex* SY, cufftDoubleComplex* SZ,
			          cufftDoubleComplex* EX, cufftDoubleComplex* EY, cufftDoubleComplex* EZ, double* F, 
                                  cufftDoubleComplex* N, 
			          cufftDoubleComplex* KX, double* X, 
			          cufftDoubleComplex* KY, double* Y, 
			          double k0, double dz, double dx, double dy, int nx, int ny, int k, 
                                  bool do_evanescent_modes ) {
	
	/* EXAMPLE
	 *
	 *   int i = blockIdx.y * blockDim.y + threadIdx.y; // space index X
	 *   int j = blockIdx.x * blockDim.x + threadIdx.x; // space index Y
         *   if(i<nx && j<ny) {
         *   }
         */

}

void YOUR_kernelWrapper_3D( int blockSize,
                            cufftDoubleComplex* EX, cufftDoubleComplex* EY, cufftDoubleComplex* EZ, double* F, 
                            const cufftDoubleComplex* host_N, cufftDoubleComplex* device_N, 
			    cufftDoubleComplex* KX, double* X, 
			    cufftDoubleComplex* KY, double* Y, 
                            double k0, double dz, double dy, double dx, int nz, int ny, int nx, 
                            bool do_evanescent_modes,
			    bool is_debug ) {
	
	/* EXAMPLE
	 *
	 *  cufftHandle plan;
	 *  cufftPlan2d(&plan, nx, ny, CUFFT_Z2Z);
         *
	 *  cufftDoubleComplex* SX;
	 *  cudaMalloc(&SX, (nx*ny)*sizeof(cufftDoubleComplex));
         *
	 *  dim3 block_dim(blockSize, blockSize, 1);
	 *   dim3 grid_dim(ceil(static_cast<double>(nx)/static_cast<double>(blockSize)), 
	 *                 ceil(static_cast<double>(ny)/static_cast<double>(blockSize)),
         *	          1);
         *
	 *  cufftExecZ2Z(plan, EX+k*(nx*ny), SX, CUFFT_FORWARD);
	 *  naiveKernel_3D<<<grid_dim, block_dim>>>( SX, SY, SZ, 
	 *    			       		     EX, EY, EZ, F, 
	 *					     N, 
	 *					     KX, X, 
	 *					     KY, Y, 
	 *					     k0, dz, dx, dy, nx, ny, k, 
	 *					     do_evanescent_modes);
         *
         */

				// PUT YOUR CODE HERE

}

/*
 *  3D scalar
 */

__global__ void YOUR_kernel_3D( cufftDoubleComplex* S, 
	   		        cufftDoubleComplex* E, double* F, 
                                cufftDoubleComplex* N, 
			        cufftDoubleComplex* KX, double* X, 
			        cufftDoubleComplex* KY, double* Y, 
                                double k0, double dz, double dx, double dy, int nx, int ny, int k, 
                                bool do_evanescent_modes, bool is_TE ) {

				// PUT YOUR CODE HERE
	
}

/* REMARK: Use YOUR_kernel_3D_2 with Split-Step algorithms like for example the BPM */
__global__ void YOUR_kernel_3D_2( cufftDoubleComplex* S, 
	   		          cufftDoubleComplex* E, double* F, 
				  cufftDoubleComplex* N, 
			          cufftDoubleComplex* KX, double* X, 
			          cufftDoubleComplex* KY, double* Y, 
                                  double k0, double dz, double dx, double dy, int nx, int ny, int k, 
                                  bool do_evanescent_modes, bool is_TE ) {

				  // PUT YOUR CODE HERE
	
}

void YOUR_kernelWrapper_3D( int blockSize,
                            cufftDoubleComplex* E, double* F, 
                            const cufftDoubleComplex* host_N, cufftDoubleComplex* device_N, 
			    cufftDoubleComplex* KX, double* X, 
			    cufftDoubleComplex* KY, double* Y, 
                            double k0, double dz, double dy, double dx, int nz, int ny, int nx, 
                            bool do_evanescent_modes, bool is_TE,
			    bool is_debug ) {

			    // PUT YOUR CODE HERE

}

/*
 *  2D vectorial
 */

__global__ void YOUR_kernel_2D( cufftDoubleComplex* SX, cufftDoubleComplex* SY, cufftDoubleComplex* SZ, 
	   	                cufftDoubleComplex* EX, cufftDoubleComplex* EY, cufftDoubleComplex* EZ, double* F, 
				cufftDoubleComplex* N, 
				cufftDoubleComplex* KX, double* X, 
				double k0, double dz, double dx, int nx, int k, 
				bool do_evanescent_modes ) {

			    	// PUT YOUR CODE HERE

}

/* REMARK: Use YOUR_kernel_2D_2 with Split-Step algorithms like for example the BPM */
__global__ void YOUR_kernel_2D_2( cufftDoubleComplex* SX, cufftDoubleComplex* SY, cufftDoubleComplex* SZ, 
	   	                  cufftDoubleComplex* EX, cufftDoubleComplex* EY, cufftDoubleComplex* EZ, double* F, 
				  cufftDoubleComplex* N, 
				  cufftDoubleComplex* KX, double* X, 
				  double k0, double dz, double dx, int nx, int k, 
				  bool do_evanescent_modes ) {

			    	  // PUT YOUR CODE HERE

}

void YOUR_kernelWrapper_2D( int blockSize,
                            cufftDoubleComplex* EX, cufftDoubleComplex* EY, cufftDoubleComplex* EZ, double* F, 
			    const cufftDoubleComplex* host_N, cufftDoubleComplex* device_N, 
			    cufftDoubleComplex* KX, double* X, 
			    double k0, double dz, double dx, int nz, int nx, 
			    bool do_evanescent_modes,
			    bool is_debug ) {

			    	  // PUT YOUR CODE HERE

}

/*
 *  2D scalar
 */


__global__ void YOUR_kernel_2D( cufftDoubleComplex* S, 
	   			cufftDoubleComplex* E, double* F, 
				cufftDoubleComplex* N, 
	   			cufftDoubleComplex* KX, double* X, 
				double k0, double dz, double dx, int nx, int k, 
				bool do_evanescent_modes, bool is_TE ) {

				// PUT YOUR CODE HERE

}

/* REMARK: Use YOUR_kernel_2D_2 with Split-Step algorithms like for example the BPM */
__global__ void YOUR_kernel_2D_2( cufftDoubleComplex* S, 
	   			  cufftDoubleComplex* E, double* F, 
				  cufftDoubleComplex* N, 
	   			  cufftDoubleComplex* KX, double* X, 
				  double k0, double dz, double dx, int nx, int k, 
				  bool do_evanescent_modes, bool is_TE ) {

				// PUT YOUR CODE HERE

}

void YOUR_kernelWrapper_2D( int blockSize,
			    cufftDoubleComplex* E, double* F, 
     			    const cufftDoubleComplex* host_N, cufftDoubleComplex* device_N, 
			    cufftDoubleComplex* KX, double* X, 
			    double k0, double dz, double dx, int nz, int nx, 
			    bool do_evanescent_modes, bool is_TE,
			    bool is_debug ) {
	
	/* EXAMPLE
	 *
	 *	cufftHandle plan;
	 *	cufftPlan1d(&plan, nx, CUFFT_Z2Z, 1);
	 *
	 *	cufftDoubleComplex* S;
	 *	cudaMalloc(&S, nx*sizeof(cufftDoubleComplex));
	 *
	 *	dim3 block_dim(blockSize, 1, 1);
	 *	dim3 grid_dim(ceil(static_cast<double>(nx)/static_cast<double>(blockSize)),1,1);
	 *
	 *	for(int k=0; k<nz-1; k++) {
	 *		cufftExecZ2Z(plan, E+k*nx, S, CUFFT_FORWARD);
	 *		YOUR_naiveKernel_2D<<<grid_dim, block_dim>>>( S, 
	 *							      E, F, 
	 *							      N, 
	 *							      KX, X, 
	 *							      k0, dz, dx, nx, k, 
	 *							      do_evanescent_modes, is_TE);
	 *	}
	 *
	 */


				// PUT YOUR CODE HERE

}


/* some nice utility functions to make life a little easier ... */


/* complex math functions */

__host__ __device__ static __inline__ cuDoubleComplex cuCmul(cuDoubleComplex x, double y) {
	return make_cuDoubleComplex(cuCreal(x) * y, cuCimag(x) * y);
}

__host__ __device__ static __inline__ cuDoubleComplex cuCdiv(cuDoubleComplex x, double y) {
	return make_cuDoubleComplex(cuCreal(x) / y, cuCimag(x) / y);
}

__host__ __device__ static __inline__ cuDoubleComplex cuCexp(cuDoubleComplex x) {
	double factor = std::exp(cuCreal(x));
	return make_cuDoubleComplex(factor * std::cos(cuCimag(x)), factor * std::sin(cuCimag(x)));
}

__host__ __device__ static __inline__ cuDoubleComplex cuCsqrt(cuDoubleComplex x) {
	if(x.x==0 && x.y==0) return make_cuDoubleComplex(0, 0);	
	double radius = cuCabs(x);
	double cosA = x.x / radius;
	cuDoubleComplex out;
	out.x = std::sqrt(radius * (cosA + 1.0) / 2.0);
	out.y = std::sqrt(radius * (1.0 - cosA) / 2.0);
	// signbit should be false if x.y is negative
	if (signbit(x.y))
		out.y *= -1.0;
	return out;
}

/* overload */

__host__ __device__ static __inline__ cuDoubleComplex operator*(cuDoubleComplex x, double y) {
	return cuCmul(x,y);
}

__host__ __device__ static __inline__ cuDoubleComplex operator/(cuDoubleComplex x, double y) {
	return cuCdiv(x,y);
}

__host__ __device__ static __inline__ cuDoubleComplex operator+(cuDoubleComplex x, cuDoubleComplex y) {
	return cuCadd(x,y);
}

__host__ __device__ static __inline__ cuDoubleComplex operator-(cuDoubleComplex x, cuDoubleComplex y) {
	return cuCsub(x,y);
}

__host__ __device__ static __inline__ cuDoubleComplex operator*(cuDoubleComplex x, cuDoubleComplex y) {
	return cuCmul(x,y);
}

__host__ __device__ static __inline__ cuDoubleComplex operator/(cuDoubleComplex x, cuDoubleComplex y) {
	return cuCdiv(x,y);
}

